%{
#include "definitions.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

extern int lineno; 
struct list *find,*find2;
char *name,*help;
int namegenerator;
%}

%token CONFLICT
%token CON_TEL
%token NUMBER
%token STRINGB STRINGA
%token TELESTHS1 TELESTHS2 TELESTHS3

%left STRINGA STRINGB
%left TELESTHS1 TELESTHS2 TELESTHS3

%start program

%union {
int i_type;
char *s_type;
char c_type;
}
%type <s_type> met_stath atom_args atom Literal Literal2 Literal3 atom_list Rules Dedomena helps
%type <s_type> TELESTHS1 TELESTHS2 TELESTHS3 STRINGA STRINGB CONFLICT CON_TEL NUMBER

%%

program:	Rules 
		| Dedomena
		| Greater
		| Conflict
		| program Rules
		| program Dedomena
		| program Greater
		| program Conflict
		;

Conflict:	CONFLICT CON_TEL helps Conflict2 '.'
                {
                ;
                }
		;

helps:		Literal3 ',' helps
		| Literal3
		;

Conflict2:	',' Literal3
                {
                data = (struct list*)malloc(sizeof(struct list));
                data->index = 6;
                data->types.conf = (struct conflict *)malloc(sizeof(struct conflict));
                data->types.conf->name=strdup("conflict");
                insert_symboltable(data);
                ++top;
                }
		| Conflict2 ',' Literal3
                {
                ;
                }
		| 
		{
                data = (struct list*)malloc(sizeof(struct list));
                data->index = 6;
                data->types.conf = (struct conflict *)malloc(sizeof(struct conflict));
                data->types.conf->name=strdup("conflict");
                insert_symboltable(data);
                ++top;
		}
                ;

Greater:	| met_stath '>' met_stath '.'
                {
                /*8elw na brw an oi duo kanones uparxoun ston symbol table */
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                find = lookup_symboltable($1);
                if(find == NULL){
                        printf("\nWRONG!Rule <%s> in line %d has not Defined!\n",$1,lineno);
                        ok=0;
                }
                find = lookup_symboltable($3);
                if(find == NULL){
                        printf("\nWRONG!Rule <%s> in line %d has not Defined!\n",$3,lineno);
                        ok=0;
                }
                else{
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 5;
                        data->types.great = (struct greater*)malloc(sizeof(struct greater));
                        data->types.great->rule1 = strdup($1);
                        data->types.great->rule2 = strdup($3);
                        insert_symboltable(data);
			++top;
			exist[2]=1;
                }
                }
		;

Dedomena:	Literal2
		{
		assert($$ = strdup($1));
		exist[0]=1;
		}
		;
			
Rules:	met_stath ':' atom_list TELESTHS1 Literal '.'
	{
	/*8elw na eisagw enan kanona ston symbol table */
	find = lookup_symboltable($1);
	/*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
	if(find == NULL){
		if(lookup_generaltable($1,3)!=NULL){
			printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
			ok=0;
		}
		if(lookup_generaltable($1,2)!=NULL){
			printf("\nWRONG!Rule <$s> in line %d is already defined as variable!\n",$1,lineno);
			ok=0;
		}
		else {
			gen = (struct general*)malloc(sizeof(struct general));
			gen->index = 1;
			gen->name = strdup($1);
			insert_info_togeneraltable(gen);
			data = (struct list*)malloc(sizeof(struct list));
			data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
			data->types.kan->name = strdup($1);
			data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
			data->types.kan->telesths = 1;
			insert_symboltable(data);
			++top;
			exist[3]=1;
		}
	}
	/*ean to brw petaw semantic la8os!*/
	else{
		printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,$1);
		ok=0;
	}
	}
	| met_stath ':' atom_list TELESTHS2 Literal '.'
	{
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($1);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
                        ok=0;
                }
                if(lookup_generaltable($1,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$1,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
	                //puts($1);
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas)); 
        	        data->types.kan->name = strdup($1);
        	        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
        	        data->types.kan->telesths = 2;
        	        insert_symboltable(data);
			++top;
			exist[1]=1;
		}
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,$1);
		ok=0;
	}
	}
        | met_stath ':' atom_list TELESTHS3 Literal '.'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($1);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
                        ok=0;
                }
                if(lookup_generaltable($1,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$1,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
                        //puts($1);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($1);
                        data->types.kan->kind1 = 1;
                        data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 3;
                        insert_symboltable(data);
                        ++top;
			exist[4]=1;
                }
        }
        /*ean to brw petaw semantic la8os!*/
	else{
		printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,$1);
		ok=0;
	}
	}
        | met_stath ':' TELESTHS1 Literal '.'
	{
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($1);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
                        ok=0;
                }
                if(lookup_generaltable($1,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$1,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
        	        data = (struct list*)malloc(sizeof(struct list));
                	data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                	data->types.kan->name = strdup($1);
                	data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                	data->types.kan->telesths = 1;
                	insert_symboltable(data);
			++top;
			exist[3]=1;
		}
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWrong!In line %d Rule <%s> redefine!\n",lineno,$1);
		ok=0;
	}
	}
	| met_stath ':' TELESTHS2 Literal '.'
	{
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($1);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
                        ok=0;
                }
                if(lookup_generaltable($1,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line  %d is already defined as variable!\n",$1,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        	        data->types.kan->name = strdup($1);
        	        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
        	        data->types.kan->telesths = 2;
        	        insert_symboltable(data);
			++top;
			exist[1]=1;
		}
	}
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,$1);
		ok=0;
	}
        }
        | met_stath ':' TELESTHS3 Literal '.'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($1);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$1,lineno);
                        ok=0;
                }
                if(lookup_generaltable($1,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line  %d is already defined as variable!\n",$1,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($1);
                        data->types.kan->kind1 = 1;   
                        data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 3;
                        insert_symboltable(data);
                        ++top;
			exist[4]=1;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,$1);
                ok=0;
        }
        }
	| atom_list TELESTHS1 Literal '.'
	{
        /*8elw na eisagw enan kanona xwris label ston symbol table */
	/* dou dinw ena tuxaio onoma*/
        data = (struct list*)malloc(sizeof(struct list));
	data->index = 1;
	data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
	data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
	++namegenerator;
	data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
	data->types.kan->telesths = 1;
	insert_symboltable(data);
        ++top;
	exist[3]=1;
	}
	| atom_list TELESTHS2 Literal '.'
	{
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
	exist[1]=1;
	}
        | atom_list TELESTHS3 Literal '.'
        {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;
        data->types.kan->kind2 = 1;
        data->types.kan->telesths = 3;
        insert_symboltable(data);
        ++top;
	exist[4]=1;
        }
	| TELESTHS1 Literal '.'
	{
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
	++namegenerator;
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
	exist[3]=1;
	}
        | TELESTHS2 Literal '.'
        {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
	data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
	data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
	exist[1]=1;
	}
        | TELESTHS3 Literal '.'
        {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;   
        data->types.kan->kind2 = 2;
        data->types.kan->telesths = 3;
        insert_symboltable(data);
        ++top;
	exist[4]=1;
        }
	;

atom_list:	Literal
		{ 
		assert($$ = strdup($1));
		}
		| atom_list ',' Literal 
		{;}
		;

Literal:	atom
		;

Literal2:	STRINGB '.'
		{
		if(lookup_generaltable($1,3)!=NULL){
			printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$1,lineno);
			ok=0;
		}
		else {
			gen = (struct general*)malloc(sizeof(struct general));
			gen->index = 2;
			gen->name = strdup($1);
			insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
			data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup($1);
        	        data->types.ded->not = 2;
        	        insert_symboltable(data);
			++top;
		}
		assert($$ = strdup($1));
		}
		| '~' STRINGB '.'
                {
                if(lookup_generaltable($2,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$2,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($2);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup($2);
                	data->types.ded->not = 1;
                	insert_symboltable(data);
	                ++top;
		}
		assert($$ = strdup($2));
                }
                | STRINGB '(' atom_args ')' '.'
                {
                if(lookup_generaltable($1,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$1,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($1);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup($1);
			data->types.ded->arguments = insert_args_to_table($3);
        	        data->types.ded->not = 2;
        	        insert_symboltable(data);
			++top;
		}
		assert($$ = strdup(strcat(strcat(strcat($1,strdup("(")),$3),strdup(")"))));
                }
                | '~' STRINGB '(' atom_args ')' '.'
                {
                if(lookup_generaltable($2,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$2,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($2);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup($2);
			data->types.ded->arguments = insert_args_to_table($4);
        	        data->types.ded->not = 1;
        	        insert_symboltable(data);
			++top;
		}
		assert($$ = strdup(strcat(strcat(strcat($2,strdup("(")),$4),strdup(")"))));
                }
		;

Literal3:       STRINGB
                {

                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($1);
						//    printf("HAHAHA");
                        data->types.ded->not = 2;
			insert_ded_tobodytable(data);

                assert($$ = strdup($1));
                }
                | '~' STRINGB
                {

                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($2);
                        data->types.ded->not = 1;   
                        insert_ded_tobodytable(data);

                assert($$ = strdup($2));
                }
                | STRINGB '(' atom_args ')'
                {
	                  data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($1);
                        data->types.ded->arguments = insert_args_to_table($3);
                        data->types.ded->not = 2;
                        insert_ded_tobodytable(data);

                assert($$ = strdup(strcat(strcat(strcat($1,strdup("(")),$3),strdup(")"))));
                }
                | '~' STRINGB '(' atom_args ')'
                {
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;   
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($2);
                        data->types.ded->arguments = insert_args_to_table($4);
                        data->types.ded->not = 1;
                        insert_ded_tobodytable(data);
                assert($$ = strdup(strcat(strcat(strcat($2,strdup("(")),$4),strdup(")"))));
                }
		|
		{;}
                ;

atom:		met_stath 
		{ 
				gen = (struct general*)malloc(sizeof(struct general));
				gen->index = 2;
				gen->name = strdup($1);
				insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                        	data->index = 2;
                        	data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        	data->types.ded->name = strdup($1);
				data->types.ded->not = 2;
                        	insert_ded_tobodytable(data);
		assert($$ = strdup($1));
		}

		| '~' met_stath
		{
		                    gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($2);
                                insert_info_togeneraltable(gen);
	                        data = (struct list*)malloc(sizeof(struct list));
        	                data->index = 2;
                	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                	        data->types.ded->name = strdup($2);
                	        data->types.ded->not = 1;
                	        insert_ded_tobodytable(data);
		assert($$ = strdup($2)); /*sigoyra*/
		}
		
		| met_stath '(' atom_args ')'  
		{
                                 gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($1);
                                insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                	        data->index = 2;
                	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                	        data->types.ded->name = strdup($1);
				data->types.ded->arguments = insert_args_to_table($3);
                        	data->types.ded->not = 2;
                        	insert_ded_tobodytable(data);
		assert($$ = strdup(strcat(strcat(strcat($1,strdup("(")),$3),strdup(")"))));
		}

		| '~' met_stath '(' atom_args ')'
		{
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($2);
                                insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                	        data->index = 2;
                        	data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
				data->types.ded->name = strdup($2);
				data->types.ded->arguments = insert_args_to_table($4);
                	        data->types.ded->not = 1;
                	        insert_ded_tobodytable(data);

		assert($$ = strdup(strcat(strcat(strcat($2,strdup("(")),$4),strdup(")"))));
		}
                | error '(' {;}
                | error ',' {;}
                | error '\n' {;}
		;

atom_args:	met_stath 
		{ 
		assert($$ = strdup($1)); 
		}
		| NUMBER
		{
		assert($$ = strdup($1)); 
		}
		| met_stath '.' atom_args
		{
		assert($$ = strdup(strcat(strcat($1,"."),$3))); 
		}
		| met_stath ':' atom_args
		{
		assert($$ = strdup(strcat(strcat($1,":"),$3))); 
		}
		| met_stath ',' atom_args
		{ 
		assert($$ = strdup(strcat(strcat($1,","),$3))); 
		}
		| NUMBER ',' atom_args
		{
		assert($$ = strdup(strcat(strcat($1,","),$3))); 
		}
		;
			
met_stath:	STRINGA 
		{ assert($$ = strdup($1)); }
		| STRINGB 
		{ assert($$ = strdup($1)); }
		;



%%
#include <stdio.h>

void yyerror(char *s){
  printf("\nWRONG!Syntax error in  line %d\n ", lineno);
  ok=0;  
}

int main(){
   int i;

   ok=1;
   namegenerator=1;

	yyparse();
	if(ok==1){
	//	parse1();
	//	parse2();
	//	parse3();
		//print_symboltable();
		//print_bodytable();
	//	produce_exports();
		produce_code();
	//	printf("definitely(C(X)):- rdf(X,rdf:type,C).\n");
	//	printf("definitely(C(X)):- rdf(Sc,rdfs:subClassOf,C),definitely(Sc(X)).\n");
	//	printf("definitely(X(P,Y)):-  rdf(Sp,rdfs:subPropertyOf,P),rdf(X,Sp,Z).\n");
	//	printf("definitely(D(X)):- rdf(P,rdfs:domain,D),rdf(X,P,Z).\n");
	//	printf("definitely(R(X)):- rdf(P,rdfs:range,R),rdf(X,P,Z).\n");
	//	printf("definitely(X(Y,Z)):- rdf(X,Y,Z).\n");
	//	printf("defeasibly(X(Y,Z)):- rdf(X,Y,Z).\n");
	}
	return(0);
}
/*-------------------------------------------------------------------------*/
/* paragei code gia olo to programma                                       */
/*-------------------------------------------------------------------------*/
void produce_code(void){
   int i=0;

for(i=0; i<top; ++i){
        //kanonas
        if(symbol_table[i]->index==1){
                //KANONAS ME LABEL
                if(symbol_table[i]->types.kan->kind1==1){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      R2: p(x,a),u => l(w)	ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(1,i);
                                //tou stul     R2: p(x,a),u -> l(w)		OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(2,i);
                                //tou stul     R2: p(x,a),u ~> l(w)	DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(3,i);
                        }
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul     R2:  => l(w)		ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(4,i);
                                //tou stul     R2:  -> l(w)		OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(5,i);
                                //tou stul     R2:  ~> l(w)		DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(6,i);
                        }
                }
                //kanonas xwris label
                else if(symbol_table[i]->types.kan->kind1==2){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      p(x,a),u => l(w)	ANAZHTHSH
				if(symbol_table[i]->types.kan->telesths==2)
					produce_ruletags(7,i);
                                //tou stul      p(x,a),u -> l(w)	OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(8,i);
                                //tou stul      p(x,a),u ~> l(w)	DEN MAS ENDIAFEROUN!
				else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(9,i);
                        }
                        //kanonas xwris body
			else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul      => l(w)			ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(10,i);
                                //tou stul      -> l(w)			???
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(11,i);
                                //tou stul      ~> l(w)			DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(12,i);
                        }
                }
        }
        //gegonos
        else if(symbol_table[i]->index==2){
		produce_fact_atomtags(symbol_table[i]);
        }
        //greater
        else if(symbol_table[i]->index==5){
                produce_greatertags(symbol_table[i]);
        }
	//conflicts
	else if(symbol_table[i]->index==6)
		;//puts("conflict");
}
}
/*-------------------------------------------------------------------------*/
/* paragei fact tags tou stul a(n) 'h x(ax,I,o) 'h -k                      */
/*-------------------------------------------------------------------------*/
void produce_fact_atomtags(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j,not;

//olh h plhroforia pou xreiazomaste einai
//1)ean exw r1>r2 'h -p(a) 2)ton deikth ston kombo
if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
not = lista->types.ded->not;

//-----
printf("fact(");
if(not==1){	printf("~(");	}
printf("%s",name);
produce_attributes(lista);
if(not==1){	printf(")");	}
printf(").\n");
//-----
return;
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h -k                      */
/*-------------------------------------------------------------------------*/
void produce_atomtags3(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j,not;

if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
not = lista->types.ded->not;

if(not==1){
        printf("~(");
}
printf("%s",name);
produce_attributes(lista);
if(not==1){
        printf(")");
}
return;
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h k(xwris thn  ~          */
/*-------------------------------------------------------------------------*/
void produce_atomtags4(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j;

if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
printf("%s",name);
produce_attributes(lista);
return;
}
/*-------------------------------------------------------------------------*/
/* Psaxnei ston body table gia head = name anti8eto apo ayto pou einai (~)*/
/* kaluptei kai tous noname kanones!*/
/*-------------------------------------------------------------------------*/
int *find_opposite(int start,struct list *lista_ar){
   //start:apo poia 8esh tou body table 8a arxisei h anazhthsh
   struct list *lista;
   int *apotel;
   int i,size=0;
   apotel = (int *)calloc(size+1,sizeof(int));

	for(i=start; i<STACKSIZE; ++i){
		lista=body_table[i];
		//to brhkame!
		if(lista && lista->types.ded && strcmp(lista_ar->types.ded->name,lista->types.ded->name)==0 && lista->types.ded->not!=lista_ar->types.ded->not && comparison2(lista,lista_ar)>0){
			apotel[size]=i;
			++size;
			apotel = (int *)realloc((int *)apotel,(size+1)*sizeof(int));
		}
	}
	return apotel;
}
/*-------------------------------------------------------------------------*/
/* Psaxnei ston body table gia head = name anti8eto apo ayto pou einai (~) kai epistrefei to mege8os tou*/
/* kaluptei kai tous noname kanones!*/
/*-------------------------------------------------------------------------*/
int find_opposite2(int start,struct list *lista_ar){
   //start:apo poia 8esh tou body table 8a arxisei h anazhthsh
   struct list *lista;
   int i,size=0;

        for(i=start; i<STACKSIZE; ++i){
                lista=body_table[i];
                //to brhkame!
		if(lista && lista->types.ded && strcmp(lista_ar->types.ded->name,lista->types.ded->name)==0 && lista->types.ded->not!=lista_ar->types.ded->not && comparison2(lista,lista_ar)>0){
			++size;
		}
        }
        return size;
}
/*-------------------------------------------------------------------------*/
/* paragei ta tags*/
/*-------------------------------------------------------------------------*/
void produce_ruletags(int kindoftags,int epipedo){
   //kindoftags 1-12:rule tags
   //epipedo:...
   struct list *lista;
   int i=0,j=0,size,*apotel,not;

	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      R2: p(x,a),u => l(w)		EAN KANONAS           r: a,~b=>x.
	//++++++++++++++++++++++++++++++++++++++++++++++
	if(kindoftags==1){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
	}

	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul     R2: p(x,a),~u -> l(w)
	//definitely(l(w)):- definitely(p(x,a)), definitely(~(u)).
	//defeasibly(l(w)):- definitely(l(w))
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==2){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
        }
	//++++++++++++++++++++++++++++++++++++++++++++++
        //tou stul     R2: p(x,a),u ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==3){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  => x
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==4){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  -> l(w)
	//definitely(l(w)).
	//defeasibly(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==5){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==6){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      p(x,a),u => l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==7){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");

        }
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      p(x,a),u -> l(w)
	//definitely(l(w)):- definitely(p(x,a)), definitely(u).
	//defeasibly(l(w)):- definitely(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==8){
  		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
        }
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      p(x,a),u ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==9){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      => l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==10){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      -> l(w)
	//definitely(l(w)).
	//defeasibly(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==11){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");        }
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==12){
		;
	}

}

/*-------------------------------------------------------------------------*/
