/* A Bison parser, made by GNU Bison 1.875b.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CONFLICT = 258,
     CON_TEL = 259,
     NUMBER = 260,
     STRINGB = 261,
     STRINGA = 262,
     TELESTHS1 = 263,
     TELESTHS2 = 264,
     TELESTHS3 = 265
   };
#endif
#define CONFLICT 258
#define CON_TEL 259
#define NUMBER 260
#define STRINGB 261
#define STRINGA 262
#define TELESTHS1 263
#define TELESTHS2 264
#define TELESTHS3 265




/* Copy the first part of user declarations.  */
#line 1 "_yacc_meta2.y"

#include "definitions.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

extern int lineno; 
struct list *find,*find2;
char *name,*help;
int namegenerator;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 24 "_yacc_meta2.y"
typedef union YYSTYPE {
int i_type;
char *s_type;
char c_type;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 114 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 126 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  33
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   136

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  19
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  15
/* YYNRULES -- Number of rules. */
#define YYNRULES  57
/* YYNRULES -- Number of states. */
#define YYNSTATES  118

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   265

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      18,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      16,    17,     2,     2,    12,     2,    11,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    14,     2,
       2,     2,    13,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    15,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    14,    17,    20,
      23,    29,    33,    35,    38,    42,    43,    44,    49,    51,
      58,    65,    72,    78,    84,    90,    95,   100,   105,   109,
     113,   117,   119,   123,   125,   128,   132,   138,   145,   147,
     150,   155,   161,   162,   164,   167,   172,   178,   181,   184,
     187,   189,   191,   195,   199,   203,   207,   209
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      20,     0,    -1,    26,    -1,    25,    -1,    24,    -1,    21,
      -1,    20,    26,    -1,    20,    25,    -1,    20,    24,    -1,
      20,    21,    -1,     3,     4,    22,    23,    11,    -1,    30,
      12,    22,    -1,    30,    -1,    12,    30,    -1,    23,    12,
      30,    -1,    -1,    -1,    33,    13,    33,    11,    -1,    29,
      -1,    33,    14,    27,     8,    28,    11,    -1,    33,    14,
      27,     9,    28,    11,    -1,    33,    14,    27,    10,    28,
      11,    -1,    33,    14,     8,    28,    11,    -1,    33,    14,
       9,    28,    11,    -1,    33,    14,    10,    28,    11,    -1,
      27,     8,    28,    11,    -1,    27,     9,    28,    11,    -1,
      27,    10,    28,    11,    -1,     8,    28,    11,    -1,     9,
      28,    11,    -1,    10,    28,    11,    -1,    28,    -1,    27,
      12,    28,    -1,    31,    -1,     6,    11,    -1,    15,     6,
      11,    -1,     6,    16,    32,    17,    11,    -1,    15,     6,
      16,    32,    17,    11,    -1,     6,    -1,    15,     6,    -1,
       6,    16,    32,    17,    -1,    15,     6,    16,    32,    17,
      -1,    -1,    33,    -1,    15,    33,    -1,    33,    16,    32,
      17,    -1,    15,    33,    16,    32,    17,    -1,     1,    16,
      -1,     1,    12,    -1,     1,    18,    -1,    33,    -1,     5,
      -1,    33,    11,    32,    -1,    33,    14,    32,    -1,    33,
      12,    32,    -1,     5,    12,    32,    -1,     7,    -1,     6,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    34,    34,    35,    36,    37,    38,    39,    40,    41,
      44,    50,    51,    54,    63,    68,    78,    78,   105,   112,
     149,   187,   225,   262,   299,   336,   353,   369,   385,   401,
     417,   435,   439,   443,   446,   468,   490,   513,   538,   551,
     563,   575,   587,   590,   605,   620,   636,   652,   653,   654,
     657,   661,   665,   669,   673,   677,   683,   685
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CONFLICT", "CON_TEL", "NUMBER", "STRINGB", 
  "STRINGA", "TELESTHS1", "TELESTHS2", "TELESTHS3", "'.'", "','", "'>'", 
  "':'", "'~'", "'('", "')'", "'\\n'", "$accept", "program", "Conflict", 
  "helps", "Conflict2", "Greater", "Dedomena", "Rules", "atom_list", 
  "Literal", "Literal2", "Literal3", "atom", "atom_args", "met_stath", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,    46,    44,    62,    58,   126,    40,    41,    10
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    19,    20,    20,    20,    20,    20,    20,    20,    20,
      21,    22,    22,    23,    23,    23,    24,    24,    25,    26,
      26,    26,    26,    26,    26,    26,    26,    26,    26,    26,
      26,    27,    27,    28,    29,    29,    29,    29,    30,    30,
      30,    30,    30,    31,    31,    31,    31,    31,    31,    31,
      32,    32,    32,    32,    32,    32,    33,    33
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     2,     2,     2,     2,
       5,     3,     1,     2,     3,     0,     0,     4,     1,     6,
       6,     6,     5,     5,     5,     4,     4,     4,     3,     3,
       3,     1,     3,     1,     2,     3,     5,     6,     1,     2,
       4,     5,     0,     1,     2,     4,     5,     2,     2,     2,
       1,     1,     3,     3,     3,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,    57,    56,     0,     0,     0,     0,     0,
       5,     4,     3,     2,     0,    31,    18,    33,    43,    48,
      47,    49,    42,    34,     0,    57,     0,     0,    43,     0,
       0,    57,    44,     1,     9,     8,     7,     6,     0,     0,
       0,     0,     0,     0,     0,    38,     0,    15,    12,    51,
       0,    50,    28,    29,    30,    35,     0,     0,     0,     0,
       0,    32,     0,     0,     0,     0,     0,     0,     0,    39,
      42,     0,    42,     0,     0,     0,     0,     0,     0,     0,
      25,    26,    27,    17,     0,     0,     0,     0,     0,     0,
      45,     0,     0,    13,    10,    42,    11,    55,    36,    52,
      54,    53,     0,    46,    22,    23,    24,     0,     0,     0,
      40,     0,    14,    37,    19,    20,    21,    41
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     9,    10,    47,    71,    11,    12,    13,    14,    15,
      16,    48,    17,    50,    28
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -66
static const yysigned_char yypact[] =
{
      12,    34,     3,    -5,   -66,    64,    64,    64,    25,    87,
     -66,   -66,   -66,   -66,   101,   -66,   -66,   -66,    53,   -66,
     -66,   -66,     8,   -66,    48,   -66,    56,    -7,    -6,     6,
      14,    22,    23,   -66,   -66,   -66,   -66,   -66,    64,    64,
      64,    64,    56,    97,    48,    27,    35,    39,    46,    60,
      57,   108,   -66,   -66,   -66,   -66,    48,    48,    67,    71,
      75,   -66,    78,    64,    64,    64,   106,    74,    48,    83,
       8,    69,     8,    48,    89,    48,    48,    48,    84,    91,
     -66,   -66,   -66,   -66,   110,   112,   113,    64,    64,    64,
     -66,   100,    48,   -66,   -66,     8,   -66,   -66,   -66,   -66,
     -66,   -66,   114,   -66,   -66,   -66,   -66,   115,   116,   117,
     -66,   118,   -66,   -66,   -66,   -66,   -66,   -66
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -66,   -66,   120,    58,   -66,   122,   123,   124,    93,    -4,
     -66,   -65,   -66,   -28,     0
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -17
static const yysigned_char yytable[] =
{
      18,    27,    29,    30,    52,    93,    23,    22,    32,    18,
      44,    24,   -16,     1,    45,     2,    67,    53,     3,     4,
       5,     6,     7,    46,    51,    54,    32,     8,    78,    79,
     112,    31,     4,    55,    58,    59,    60,    61,    56,    57,
      91,    69,    62,    68,    51,    97,    19,    99,   100,   101,
      20,    70,    21,    49,    25,     4,    51,    51,    72,    84,
      85,    86,    25,     4,   111,     1,    42,    43,    51,    44,
      25,     4,    73,    51,    74,    51,    51,    51,    80,    26,
      94,    95,    81,   107,   108,   109,    82,    33,     1,    83,
       2,    90,    51,     3,     4,     5,     6,     7,     1,    92,
      98,   102,     8,    25,     4,    63,    64,    65,   103,    38,
      39,    40,    26,    41,    87,    88,    89,   110,    41,    75,
      76,   104,    77,   105,   106,   113,   114,   115,   116,    34,
      96,    35,    36,    37,     0,   117,    66
};

static const yysigned_char yycheck[] =
{
       0,     5,     6,     7,    11,    70,    11,     4,     8,     9,
      16,    16,     0,     1,     6,     3,    44,    11,     6,     7,
       8,     9,    10,    15,    24,    11,    26,    15,    56,    57,
      95,     6,     7,    11,    38,    39,    40,    41,    16,    16,
      68,     6,    42,    16,    44,    73,    12,    75,    76,    77,
      16,    12,    18,     5,     6,     7,    56,    57,    12,    63,
      64,    65,     6,     7,    92,     1,    13,    14,    68,    16,
       6,     7,    12,    73,    17,    75,    76,    77,    11,    15,
      11,    12,    11,    87,    88,    89,    11,     0,     1,    11,
       3,    17,    92,     6,     7,     8,     9,    10,     1,    16,
      11,    17,    15,     6,     7,     8,     9,    10,    17,     8,
       9,    10,    15,    12,     8,     9,    10,    17,    12,    11,
      12,    11,    14,    11,    11,    11,    11,    11,    11,     9,
      72,     9,     9,     9,    -1,    17,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     6,     7,     8,     9,    10,    15,    20,
      21,    24,    25,    26,    27,    28,    29,    31,    33,    12,
      16,    18,     4,    11,    16,     6,    15,    28,    33,    28,
      28,     6,    33,     0,    21,    24,    25,    26,     8,     9,
      10,    12,    13,    14,    16,     6,    15,    22,    30,     5,
      32,    33,    11,    11,    11,    11,    16,    16,    28,    28,
      28,    28,    33,     8,     9,    10,    27,    32,    16,     6,
      12,    23,    12,    12,    17,    11,    12,    14,    32,    32,
      11,    11,    11,    11,    28,    28,    28,     8,     9,    10,
      17,    32,    16,    30,    11,    12,    22,    32,    11,    32,
      32,    32,    17,    17,    11,    11,    11,    28,    28,    28,
      17,    32,    30,    11,    11,    11,    11,    17
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 10:
#line 45 "_yacc_meta2.y"
    {
                ;
                }
    break;

  case 13:
#line 55 "_yacc_meta2.y"
    {
                data = (struct list*)malloc(sizeof(struct list));
                data->index = 6;
                data->types.conf = (struct conflict *)malloc(sizeof(struct conflict));
                data->types.conf->name=strdup("conflict");
                insert_symboltable(data);
                ++top;
                }
    break;

  case 14:
#line 64 "_yacc_meta2.y"
    {
                ;
                }
    break;

  case 15:
#line 68 "_yacc_meta2.y"
    {
                data = (struct list*)malloc(sizeof(struct list));
                data->index = 6;
                data->types.conf = (struct conflict *)malloc(sizeof(struct conflict));
                data->types.conf->name=strdup("conflict");
                insert_symboltable(data);
                ++top;
		}
    break;

  case 17:
#line 79 "_yacc_meta2.y"
    {
                /*8elw na brw an oi duo kanones uparxoun ston symbol table */
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                find = lookup_symboltable(yyvsp[-3].s_type);
                if(find == NULL){
                        printf("\nWRONG!Rule <%s> in line %d has not Defined!\n",yyvsp[-3].s_type,lineno);
                        ok=0;
                }
                find = lookup_symboltable(yyvsp[-1].s_type);
                if(find == NULL){
                        printf("\nWRONG!Rule <%s> in line %d has not Defined!\n",yyvsp[-1].s_type,lineno);
                        ok=0;
                }
                else{
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 5;
                        data->types.great = (struct greater*)malloc(sizeof(struct greater));
                        data->types.great->rule1 = strdup(yyvsp[-3].s_type);
                        data->types.great->rule2 = strdup(yyvsp[-1].s_type);
                        insert_symboltable(data);
			++top;
			exist[2]=1;
                }
                }
    break;

  case 18:
#line 106 "_yacc_meta2.y"
    {
		assert(yyval.s_type = strdup(yyvsp[0].s_type));
		exist[0]=1;
		}
    break;

  case 19:
#line 113 "_yacc_meta2.y"
    {
	/*8elw na eisagw enan kanona ston symbol table */
	find = lookup_symboltable(yyvsp[-5].s_type);
	/*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
	if(find == NULL){
		if(lookup_generaltable(yyvsp[-5].s_type,3)!=NULL){
			printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-5].s_type,lineno);
			ok=0;
		}
		if(lookup_generaltable(yyvsp[-5].s_type,2)!=NULL){
			printf("\nWRONG!Rule <$s> in line %d is already defined as variable!\n",yyvsp[-5].s_type,lineno);
			ok=0;
		}
		else {
			gen = (struct general*)malloc(sizeof(struct general));
			gen->index = 1;
			gen->name = strdup(yyvsp[-5].s_type);
			insert_info_togeneraltable(gen);
			data = (struct list*)malloc(sizeof(struct list));
			data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
			data->types.kan->name = strdup(yyvsp[-5].s_type);
			data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
			data->types.kan->telesths = 1;
			insert_symboltable(data);
			++top;
			exist[3]=1;
		}
	}
	/*ean to brw petaw semantic la8os!*/
	else{
		printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-5].s_type);
		ok=0;
	}
	}
    break;

  case 20:
#line 150 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-5].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-5].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-5].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-5].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-5].s_type,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-5].s_type);
                        insert_info_togeneraltable(gen);
	                //puts($1);
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas)); 
        	        data->types.kan->name = strdup(yyvsp[-5].s_type);
        	        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
        	        data->types.kan->telesths = 2;
        	        insert_symboltable(data);
			++top;
			exist[1]=1;
		}
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-5].s_type);
		ok=0;
	}
	}
    break;

  case 21:
#line 188 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-5].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-5].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-5].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-5].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-5].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-5].s_type);
                        insert_info_togeneraltable(gen);
                        //puts($1);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-5].s_type);
                        data->types.kan->kind1 = 1;
                        data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 3;
                        insert_symboltable(data);
                        ++top;
			exist[4]=1;
                }
        }
        /*ean to brw petaw semantic la8os!*/
	else{
		printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-5].s_type);
		ok=0;
	}
	}
    break;

  case 22:
#line 226 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-4].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-4].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-4].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-4].s_type);
                        insert_info_togeneraltable(gen);
        	        data = (struct list*)malloc(sizeof(struct list));
                	data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                	data->types.kan->name = strdup(yyvsp[-4].s_type);
                	data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                	data->types.kan->telesths = 1;
                	insert_symboltable(data);
			++top;
			exist[3]=1;
		}
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWrong!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-4].s_type);
		ok=0;
	}
	}
    break;

  case 23:
#line 263 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-4].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-4].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-4].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line  %d is already defined as variable!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-4].s_type);
                        insert_info_togeneraltable(gen);
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 1;
			data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        	        data->types.kan->name = strdup(yyvsp[-4].s_type);
        	        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
        	        data->types.kan->telesths = 2;
        	        insert_symboltable(data);
			++top;
			exist[1]=1;
		}
	}
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-4].s_type);
		ok=0;
	}
        }
    break;

  case 24:
#line 300 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-4].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-4].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-4].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line  %d is already defined as variable!\n",yyvsp[-4].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-4].s_type);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-4].s_type);
                        data->types.kan->kind1 = 1;   
                        data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 3;
                        insert_symboltable(data);
                        ++top;
			exist[4]=1;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!In line %d Rule <%s> redefine!\n",lineno,yyvsp[-4].s_type);
                ok=0;
        }
        }
    break;

  case 25:
#line 337 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
	/* dou dinw ena tuxaio onoma*/
        data = (struct list*)malloc(sizeof(struct list));
	data->index = 1;
	data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
	data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
	++namegenerator;
	data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
	data->types.kan->telesths = 1;
	insert_symboltable(data);
        ++top;
	exist[3]=1;
	}
    break;

  case 26:
#line 354 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
	exist[1]=1;
	}
    break;

  case 27:
#line 370 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;
        data->types.kan->kind2 = 1;
        data->types.kan->telesths = 3;
        insert_symboltable(data);
        ++top;
	exist[4]=1;
        }
    break;

  case 28:
#line 386 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
	++namegenerator;
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
	exist[3]=1;
	}
    break;

  case 29:
#line 402 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
	data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
	data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
	exist[1]=1;
	}
    break;

  case 30:
#line 418 "_yacc_meta2.y"
    {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
	help=strdup("Noname");
        data->types.kan->name = strdup(strcat((char*)strdup("Noname"),itoa(namegenerator)));
        ++namegenerator;
        data->types.kan->kind1 = 2;   
        data->types.kan->kind2 = 2;
        data->types.kan->telesths = 3;
        insert_symboltable(data);
        ++top;
	exist[4]=1;
        }
    break;

  case 31:
#line 436 "_yacc_meta2.y"
    { 
		assert(yyval.s_type = strdup(yyvsp[0].s_type));
		}
    break;

  case 32:
#line 440 "_yacc_meta2.y"
    {;}
    break;

  case 34:
#line 447 "_yacc_meta2.y"
    {
		if(lookup_generaltable(yyvsp[-1].s_type,3)!=NULL){
			printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-1].s_type,lineno);
			ok=0;
		}
		else {
			gen = (struct general*)malloc(sizeof(struct general));
			gen->index = 2;
			gen->name = strdup(yyvsp[-1].s_type);
			insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
			data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup(yyvsp[-1].s_type);
        	        data->types.ded->not = 2;
        	        insert_symboltable(data);
			++top;
		}
		assert(yyval.s_type = strdup(yyvsp[-1].s_type));
		}
    break;

  case 35:
#line 469 "_yacc_meta2.y"
    {
                if(lookup_generaltable(yyvsp[-1].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-1].s_type,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-1].s_type);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup(yyvsp[-1].s_type);
                	data->types.ded->not = 1;
                	insert_symboltable(data);
	                ++top;
		}
		assert(yyval.s_type = strdup(yyvsp[-1].s_type));
                }
    break;

  case 36:
#line 491 "_yacc_meta2.y"
    {
                if(lookup_generaltable(yyvsp[-4].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-4].s_type,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-4].s_type);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup(yyvsp[-4].s_type);
			data->types.ded->arguments = insert_args_to_table(yyvsp[-2].s_type);
        	        data->types.ded->not = 2;
        	        insert_symboltable(data);
			++top;
		}
		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-4].s_type,strdup("(")),yyvsp[-2].s_type),strdup(")"))));
                }
    break;

  case 37:
#line 514 "_yacc_meta2.y"
    {
                if(lookup_generaltable(yyvsp[-4].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-4].s_type,lineno);
			ok=0;
                }
		else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-4].s_type);
                        insert_info_togeneraltable(gen);
	                /*8elw na eisagw enan kathgorhma ston symbol table */
        	        data = (struct list*)malloc(sizeof(struct list));
        	        data->index = 2;
        	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
        	        data->types.ded->name = strdup(yyvsp[-4].s_type);
			data->types.ded->arguments = insert_args_to_table(yyvsp[-2].s_type);
        	        data->types.ded->not = 1;
        	        insert_symboltable(data);
			++top;
		}
		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-4].s_type,strdup("(")),yyvsp[-2].s_type),strdup(")"))));
                }
    break;

  case 38:
#line 539 "_yacc_meta2.y"
    {

                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[0].s_type);
						//    printf("HAHAHA");
                        data->types.ded->not = 2;
			insert_ded_tobodytable(data);

                assert(yyval.s_type = strdup(yyvsp[0].s_type));
                }
    break;

  case 39:
#line 552 "_yacc_meta2.y"
    {

                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[0].s_type);
                        data->types.ded->not = 1;   
                        insert_ded_tobodytable(data);

                assert(yyval.s_type = strdup(yyvsp[0].s_type));
                }
    break;

  case 40:
#line 564 "_yacc_meta2.y"
    {
	                  data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-3].s_type);
                        data->types.ded->arguments = insert_args_to_table(yyvsp[-1].s_type);
                        data->types.ded->not = 2;
                        insert_ded_tobodytable(data);

                assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-3].s_type,strdup("(")),yyvsp[-1].s_type),strdup(")"))));
                }
    break;

  case 41:
#line 576 "_yacc_meta2.y"
    {
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;   
                        data->types.ded = (struct dedomeno *)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-3].s_type);
                        data->types.ded->arguments = insert_args_to_table(yyvsp[-1].s_type);
                        data->types.ded->not = 1;
                        insert_ded_tobodytable(data);
                assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-3].s_type,strdup("(")),yyvsp[-1].s_type),strdup(")"))));
                }
    break;

  case 42:
#line 587 "_yacc_meta2.y"
    {;}
    break;

  case 43:
#line 591 "_yacc_meta2.y"
    { 
				gen = (struct general*)malloc(sizeof(struct general));
				gen->index = 2;
				gen->name = strdup(yyvsp[0].s_type);
				insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                        	data->index = 2;
                        	data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        	data->types.ded->name = strdup(yyvsp[0].s_type);
				data->types.ded->not = 2;
                        	insert_ded_tobodytable(data);
		assert(yyval.s_type = strdup(yyvsp[0].s_type));
		}
    break;

  case 44:
#line 606 "_yacc_meta2.y"
    {
		                    gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[0].s_type);
                                insert_info_togeneraltable(gen);
	                        data = (struct list*)malloc(sizeof(struct list));
        	                data->index = 2;
                	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                	        data->types.ded->name = strdup(yyvsp[0].s_type);
                	        data->types.ded->not = 1;
                	        insert_ded_tobodytable(data);
		assert(yyval.s_type = strdup(yyvsp[0].s_type)); /*sigoyra*/
		}
    break;

  case 45:
#line 621 "_yacc_meta2.y"
    {
                                 gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-3].s_type);
                                insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                	        data->index = 2;
                	        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                	        data->types.ded->name = strdup(yyvsp[-3].s_type);
				data->types.ded->arguments = insert_args_to_table(yyvsp[-1].s_type);
                        	data->types.ded->not = 2;
                        	insert_ded_tobodytable(data);
		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-3].s_type,strdup("(")),yyvsp[-1].s_type),strdup(")"))));
		}
    break;

  case 46:
#line 637 "_yacc_meta2.y"
    {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-3].s_type);
                                insert_info_togeneraltable(gen);
        	                data = (struct list*)malloc(sizeof(struct list));
                	        data->index = 2;
                        	data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
				data->types.ded->name = strdup(yyvsp[-3].s_type);
				data->types.ded->arguments = insert_args_to_table(yyvsp[-1].s_type);
                	        data->types.ded->not = 1;
                	        insert_ded_tobodytable(data);

		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-3].s_type,strdup("(")),yyvsp[-1].s_type),strdup(")"))));
		}
    break;

  case 47:
#line 652 "_yacc_meta2.y"
    {;}
    break;

  case 48:
#line 653 "_yacc_meta2.y"
    {;}
    break;

  case 49:
#line 654 "_yacc_meta2.y"
    {;}
    break;

  case 50:
#line 658 "_yacc_meta2.y"
    { 
		assert(yyval.s_type = strdup(yyvsp[0].s_type)); 
		}
    break;

  case 51:
#line 662 "_yacc_meta2.y"
    {
		assert(yyval.s_type = strdup(yyvsp[0].s_type)); 
		}
    break;

  case 52:
#line 666 "_yacc_meta2.y"
    {
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-2].s_type,"."),yyvsp[0].s_type))); 
		}
    break;

  case 53:
#line 670 "_yacc_meta2.y"
    {
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-2].s_type,":"),yyvsp[0].s_type))); 
		}
    break;

  case 54:
#line 674 "_yacc_meta2.y"
    { 
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-2].s_type,","),yyvsp[0].s_type))); 
		}
    break;

  case 55:
#line 678 "_yacc_meta2.y"
    {
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-2].s_type,","),yyvsp[0].s_type))); 
		}
    break;

  case 56:
#line 684 "_yacc_meta2.y"
    { assert(yyval.s_type = strdup(yyvsp[0].s_type)); }
    break;

  case 57:
#line 686 "_yacc_meta2.y"
    { assert(yyval.s_type = strdup(yyvsp[0].s_type)); }
    break;


    }

/* Line 999 of yacc.c.  */
#line 1842 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 691 "_yacc_meta2.y"

#include <stdio.h>

void yyerror(char *s){
  printf("\nWRONG!Syntax error in  line %d\n ", lineno);
  ok=0;  
}

int main(){
   int i;

   ok=1;
   namegenerator=1;

	yyparse();
	if(ok==1){
	//	parse1();
	//	parse2();
	//	parse3();
		//print_symboltable();
		//print_bodytable();
	//	produce_exports();
		produce_code();
	//	printf("definitely(C(X)):- rdf(X,rdf:type,C).\n");
	//	printf("definitely(C(X)):- rdf(Sc,rdfs:subClassOf,C),definitely(Sc(X)).\n");
	//	printf("definitely(X(P,Y)):-  rdf(Sp,rdfs:subPropertyOf,P),rdf(X,Sp,Z).\n");
	//	printf("definitely(D(X)):- rdf(P,rdfs:domain,D),rdf(X,P,Z).\n");
	//	printf("definitely(R(X)):- rdf(P,rdfs:range,R),rdf(X,P,Z).\n");
	//	printf("definitely(X(Y,Z)):- rdf(X,Y,Z).\n");
	//	printf("defeasibly(X(Y,Z)):- rdf(X,Y,Z).\n");
	}
	return(0);
}
/*-------------------------------------------------------------------------*/
/* paragei code gia olo to programma                                       */
/*-------------------------------------------------------------------------*/
void produce_code(void){
   int i=0;

for(i=0; i<top; ++i){
        //kanonas
        if(symbol_table[i]->index==1){
                //KANONAS ME LABEL
                if(symbol_table[i]->types.kan->kind1==1){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      R2: p(x,a),u => l(w)	ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(1,i);
                                //tou stul     R2: p(x,a),u -> l(w)		OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(2,i);
                                //tou stul     R2: p(x,a),u ~> l(w)	DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(3,i);
                        }
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul     R2:  => l(w)		ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(4,i);
                                //tou stul     R2:  -> l(w)		OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(5,i);
                                //tou stul     R2:  ~> l(w)		DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(6,i);
                        }
                }
                //kanonas xwris label
                else if(symbol_table[i]->types.kan->kind1==2){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      p(x,a),u => l(w)	ANAZHTHSH
				if(symbol_table[i]->types.kan->telesths==2)
					produce_ruletags(7,i);
                                //tou stul      p(x,a),u -> l(w)	OK
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(8,i);
                                //tou stul      p(x,a),u ~> l(w)	DEN MAS ENDIAFEROUN!
				else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(9,i);
                        }
                        //kanonas xwris body
			else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul      => l(w)			ANAZHTHSH
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_ruletags(10,i);
                                //tou stul      -> l(w)			???
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_ruletags(11,i);
                                //tou stul      ~> l(w)			DEN MAS ENDIAFEROUN!
                                else if(symbol_table[i]->types.kan->telesths==3)
                                        produce_ruletags(12,i);
                        }
                }
        }
        //gegonos
        else if(symbol_table[i]->index==2){
		produce_fact_atomtags(symbol_table[i]);
        }
        //greater
        else if(symbol_table[i]->index==5){
                produce_greatertags(symbol_table[i]);
        }
	//conflicts
	else if(symbol_table[i]->index==6)
		;//puts("conflict");
}
}
/*-------------------------------------------------------------------------*/
/* paragei fact tags tou stul a(n) 'h x(ax,I,o) 'h -k                      */
/*-------------------------------------------------------------------------*/
void produce_fact_atomtags(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j,not;

//olh h plhroforia pou xreiazomaste einai
//1)ean exw r1>r2 'h -p(a) 2)ton deikth ston kombo
if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
not = lista->types.ded->not;

//-----
printf("fact(");
if(not==1){	printf("~(");	}
printf("%s",name);
produce_attributes(lista);
if(not==1){	printf(")");	}
printf(").\n");
//-----
return;
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h -k                      */
/*-------------------------------------------------------------------------*/
void produce_atomtags3(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j,not;

if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
not = lista->types.ded->not;

if(not==1){
        printf("~(");
}
printf("%s",name);
produce_attributes(lista);
if(not==1){
        printf(")");
}
return;
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h k(xwris thn  ~          */
/*-------------------------------------------------------------------------*/
void produce_atomtags4(struct list *lista){
   //lista:deikths pros thn alusida pou periexei ta stoixeia
   int i,j;

if(!lista){
        puts("WRONG! No symbols!");
        return;
}
//sosname = lista->types.ded->name;
name = strdup(lista->types.ded->name);
printf("%s",name);
produce_attributes(lista);
return;
}
/*-------------------------------------------------------------------------*/
/* Psaxnei ston body table gia head = name anti8eto apo ayto pou einai (~)*/
/* kaluptei kai tous noname kanones!*/
/*-------------------------------------------------------------------------*/
int *find_opposite(int start,struct list *lista_ar){
   //start:apo poia 8esh tou body table 8a arxisei h anazhthsh
   struct list *lista;
   int *apotel;
   int i,size=0;
   apotel = (int *)calloc(size+1,sizeof(int));

	for(i=start; i<STACKSIZE; ++i){
		lista=body_table[i];
		//to brhkame!
		if(lista && lista->types.ded && strcmp(lista_ar->types.ded->name,lista->types.ded->name)==0 && lista->types.ded->not!=lista_ar->types.ded->not && comparison2(lista,lista_ar)>0){
			apotel[size]=i;
			++size;
			apotel = (int *)realloc((int *)apotel,(size+1)*sizeof(int));
		}
	}
	return apotel;
}
/*-------------------------------------------------------------------------*/
/* Psaxnei ston body table gia head = name anti8eto apo ayto pou einai (~) kai epistrefei to mege8os tou*/
/* kaluptei kai tous noname kanones!*/
/*-------------------------------------------------------------------------*/
int find_opposite2(int start,struct list *lista_ar){
   //start:apo poia 8esh tou body table 8a arxisei h anazhthsh
   struct list *lista;
   int i,size=0;

        for(i=start; i<STACKSIZE; ++i){
                lista=body_table[i];
                //to brhkame!
		if(lista && lista->types.ded && strcmp(lista_ar->types.ded->name,lista->types.ded->name)==0 && lista->types.ded->not!=lista_ar->types.ded->not && comparison2(lista,lista_ar)>0){
			++size;
		}
        }
        return size;
}
/*-------------------------------------------------------------------------*/
/* paragei ta tags*/
/*-------------------------------------------------------------------------*/
void produce_ruletags(int kindoftags,int epipedo){
   //kindoftags 1-12:rule tags
   //epipedo:...
   struct list *lista;
   int i=0,j=0,size,*apotel,not;

	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      R2: p(x,a),u => l(w)		EAN KANONAS           r: a,~b=>x.
	//++++++++++++++++++++++++++++++++++++++++++++++
	if(kindoftags==1){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
	}

	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul     R2: p(x,a),~u -> l(w)
	//definitely(l(w)):- definitely(p(x,a)), definitely(~(u)).
	//defeasibly(l(w)):- definitely(l(w))
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==2){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
        }
	//++++++++++++++++++++++++++++++++++++++++++++++
        //tou stul     R2: p(x,a),u ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==3){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  => x
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==4){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  -> l(w)
	//definitely(l(w)).
	//defeasibly(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==5){
		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict(%s,~(",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict(%s,",symbol_table[epipedo]->types.kan->name);
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul     R2:  ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==6){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      p(x,a),u => l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==7){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");

        }
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      p(x,a),u -> l(w)
	//definitely(l(w)):- definitely(p(x,a)), definitely(u).
	//defeasibly(l(w)):- definitely(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==8){
  		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			lista = body_table[epipedo];
                        i = countelements(lista); 
			for(j=i; j>1; --j){
                                lista = findelement(j,body_table[epipedo]);
                        produce_atomtags3(lista);
				if (j>2) printf(",");
                        }
			printf("])");
			printf(".\n");
        }
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      p(x,a),u ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
	else if(kindoftags==9){
		;
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      => l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==10){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("defeasible([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("defeasible([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");
	}
	//++++++++++++++++++++++++++++++++++++++++++++++
        //---tou stul      -> l(w)
	//definitely(l(w)).
	//defeasibly(l(w)).
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==11){
 		lista = body_table[epipedo];
		//ean o kanonas exei not
		not=body_table[epipedo]->types.ded->not;

			if(not==1){
				printf("strict([],~(");
				produce_atomtags4(body_table[epipedo]);
				printf("),[");
			}
			else{
				printf("strict([],");
				produce_atomtags4(body_table[epipedo]);
				printf(",[");
			}
			printf("])");
			printf(".\n");        }
	//++++++++++++++++++++++++++++++++++++++++++++++
	//---tou stul      ~> l(w)
	//++++++++++++++++++++++++++++++++++++++++++++++
        else if(kindoftags==12){
		;
	}

}

/*-------------------------------------------------------------------------*/

