#include "definitions.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

/*-------------------------------------------------------------------------*/
/* checks if two literals are the same*/
/*-------------------------------------------------------------------------*/
int comparison(struct list *lista1,struct list *lista2){
   int hasargs1,hasargs2;
   struct list *help1,*help2;
        
        if(lista1==NULL || lista2==NULL){
                printf("\nFATAL ERROR\n\n");
                return -1;
        }
        if(strcmp(lista1->types.ded->name,lista2->types.ded->name)!=0)
                return -1;
        if(lista1->types.ded->arguments==NULL)
                hasargs1=0;
        else
                hasargs1=1;
        if(lista2->types.ded->arguments==NULL)
                hasargs2=0;
        else
                hasargs2=1;
        if(hasargs1!=hasargs2)
                return -1;
        if(lista1->types.ded->not!=lista2->types.ded->not)
                 return -1;
        else{
                if(hasargs1==0)
                        return 1;
                else if(hasargs1==1){
                        for(help1=lista1->types.ded->arguments,help2=lista2->types.ded->arguments; help1!=NULL && help2!=NULL; help1=help1->next,help2=help2->next){
                                if(strcmp(help1->types.ded->name,help2->types.ded->name)==0)
                                        ;
                                else
                                        return -1;
                        }
                        if((help1!=NULL && help2==NULL) || (help1==NULL && help2!=NULL))
                                return -1;
                        if(help1==help2==NULL)
                                return 1;
                }
        }       
}
/*-------------------------------------------------------------------------*/
/* checks if two literals are contradictious*/
/*-------------------------------------------------------------------------*/
int comparison2(struct list *lista1,struct list *lista2){
   int hasargs1,hasargs2; 
   struct list *help1,*help2;
                
        if(lista1==NULL || lista2==NULL){
                printf("\nFATAL ERROR\n\n");
                return -1;
        }
        if(strcmp(lista1->types.ded->name,lista2->types.ded->name)!=0)
                return -1; 
        if(lista1->types.ded->arguments==NULL)
                hasargs1=0;
        else
                hasargs1=1;
        if(lista2->types.ded->arguments==NULL)
                hasargs2=0;
        else
                hasargs2=1;
        if(hasargs1!=hasargs2)
                return -1;
        if(lista1->types.ded->not==lista2->types.ded->not)
                 return -1;
        else{
                if(hasargs1==0)
                        return 1;
                else if(hasargs1==1){
                        for(help1=lista1->types.ded->arguments,help2=lista2->types.ded->arguments; help1!=NULL && help2!=NULL; help1=help1->next,help2=help2->next){
                                if(strcmp(help1->types.ded->name,help2->types.ded->name)==0)
                                        ;
                                else
                                        return -1;
                        }
                        if((help1!=NULL && help2==NULL) || (help1==NULL && help2!=NULL))
                                return -1;
                        if(help1==help2==NULL)
                                return 1;
                }
        }       
}
/*-------------------------------------------------------------------------*/
/* converts an integer to a character*/
/*-------------------------------------------------------------------------*/
char *itoa(int n){
   char *s;
   int i,sign,size;

   s=(char *)calloc(1,sizeof(char));
   size=1;
   i=0;
        if((sign=n)<0)
                n=-n;
        do{
                s = (char *)realloc((char *)s,(size+1)*sizeof(char));
                ++size;
                s[i++]= n % 10 +'0';
        }while((n/=10)>0);
        if(sign<0)
                s[i++] = '-';
        s[i] = '\0';
        reverse(s);
        return s;
}
/*-------------------------------------------------------------------------*/
/* reverses a string */
/*-------------------------------------------------------------------------*/
int reverse(char *s){
   int c,i,j;

        for(i=0, j=strlen(s)-1; i<j; i++,j--){
                c=s[i];
                s[i]=s[j];
                s[j]=c;
        }
        return 1;
}
