%{

#include "y.tab.h"

int lineno = 1;

%}

digit                   [0-9]
number                  {digit}+
space   		[" "\t\f\v]+
character		[a-zA-Z]
stringa			[A-Z_][A-Za-z0-9\'/@_#!]*
stringb			[a-z0-9\'/@_#!][A-Za-z0-9\'/@_#!]*

%%
conflict    { return CONFLICT; }

"/*"	{ 
	int c;
	while((c=input())!=EOF) {
        if(c=='*'){
		c=input();
			if (c=='/'){
			//printf("--%d--",lineno);
                    	break;
					}
			        else if (c=='\n') {
						++lineno;
			        }
					else 
						unput(c);
				}
				else if(c=='\n')
					++lineno;
			}
		}


\'      { return '\'';}
"~"     { return '~';} 
"!"     { return '!';} 
"@"     { return '@';}
"#"     { return '#';}
"$"     { return '$';}  
"%"     { return '%';}
"^"     { return '^';}
"&"     { return '&';}
"*"     { return '*';}
"_"     { return '_';}
"\\"     { return '\\';}
"|"     { return '|';}
"."     { return '.';}
"?"     { return '?';}
";"     { return ';'; }         
":"     { return ':'; }                 
","     { return ','; }  
"-"     { return '-'; }
"="     { return '='; }
"/"     { return '/'; }
"("     { return '('; }
")"     { return ')'; }
"<"     { return '<'; }
">"     { return '>'; }
"::"	{ return CON_TEL;}
"~>"    { return TELESTHS3; }
"=>"    { return TELESTHS2; }
"->"    { return TELESTHS1; }

{number}    { yylval.s_type=(char *)strdup(yytext); return NUMBER; }
{stringa}	{ yylval.s_type=(char *)strdup(yytext); return STRINGA; }
{stringb}	{ yylval.s_type=(char *)strdup(yytext); return STRINGB; }
\n		{ lineno++; }
{space}   	{  }

%%
