/* A Bison parser, made by GNU Bison 1.875b.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRINGB = 258,
     STRINGA = 259,
     NUMBER = 260,
     DIPLH = 261,
     DEFRULE = 262,
     STRICTRULE = 263,
     NAME = 264,
     FACT = 265,
     HEAD = 266,
     BODY = 267,
     NEG = 268,
     ATOM = 269,
     PREDICATE = 270,
     TERM = 271,
     VAR = 272,
     CONST = 273,
     GREATER = 274,
     SUP = 275,
     INF = 276,
     THEPROGRAM = 277
   };
#endif
#define STRINGB 258
#define STRINGA 259
#define NUMBER 260
#define DIPLH 261
#define DEFRULE 262
#define STRICTRULE 263
#define NAME 264
#define FACT 265
#define HEAD 266
#define BODY 267
#define NEG 268
#define ATOM 269
#define PREDICATE 270
#define TERM 271
#define VAR 272
#define CONST 273
#define GREATER 274
#define SUP 275
#define INF 276
#define THEPROGRAM 277




/* Copy the first part of user declarations.  */
#line 1 "_yacc_xml.y"

#include "symbol_table_xml.h"
#include <stdio.h>
#include <assert.h>

extern int lineno;
char *_atom_args,*_met_stath;
struct list *find,*find2;
char *name;
int index,epipedo,ok=1;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 23 "_yacc_xml.y"
typedef union YYSTYPE {
int i_type;
char *s_type;
char c_type;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 138 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 150 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   350

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  27
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  12
/* YYNRULES -- Number of rules. */
#define YYNRULES  36
/* YYNRULES -- Number of states. */
#define YYNSTATES  323

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   277

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    25,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      23,    26,    24,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,    12,    14,    16,    18,    21,    24,    27,
      30,    45,    54,    83,   112,   140,   168,   192,   216,   239,
     262,   264,   267,   269,   285,   308,   325,   349,   365,   388,
     405,   429,   445,   461,   478,   495,   497
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      28,     0,    -1,    23,    22,    24,    29,    23,    25,    22,
      24,    -1,    32,    -1,    31,    -1,    30,    -1,    29,    32,
      -1,    29,    31,    -1,    29,    30,    -1,     1,     5,    -1,
      23,    19,    20,    26,     6,    38,     6,    21,    26,     6,
      38,     6,    25,    24,    -1,    23,    10,    24,    35,    23,
      25,    10,    24,    -1,    23,     7,     9,    26,     6,    38,
       6,    24,    23,    11,    24,    34,    23,    25,    11,    24,
      23,    12,    24,    33,    23,    25,    12,    24,    23,    25,
       7,    24,    -1,    23,     8,     9,    26,     6,    38,     6,
      24,    23,    11,    24,    34,    23,    25,    11,    24,    23,
      12,    24,    33,    23,    25,    12,    24,    23,    25,     8,
      24,    -1,    23,     7,     9,    26,     6,    38,     6,    24,
      23,    11,    24,    34,    23,    25,    11,    24,    23,    12,
      24,    23,    25,    12,    24,    23,    25,     7,    24,    -1,
      23,     8,     9,    26,     6,    38,     6,    24,    23,    11,
      24,    34,    23,    25,    11,    24,    23,    12,    24,    23,
      25,    12,    24,    23,    25,     8,    24,    -1,    23,     7,
      24,    23,    11,    24,    34,    23,    25,    11,    24,    23,
      12,    24,    33,    23,    25,    12,    24,    23,    25,     7,
      24,    -1,    23,     8,    24,    23,    11,    24,    34,    23,
      25,    11,    24,    23,    12,    24,    33,    23,    25,    12,
      24,    23,    25,     8,    24,    -1,    23,     7,    24,    23,
      11,    24,    34,    23,    25,    11,    24,    23,    12,    24,
      23,    25,    12,    24,    23,    25,     7,    24,    -1,    23,
       8,    24,    23,    11,    24,    34,    23,    25,    11,    24,
      23,    12,    24,    23,    25,    12,    24,    23,    25,     8,
      24,    -1,    34,    -1,    33,    34,    -1,    36,    -1,    23,
      14,    24,    23,    15,    24,     3,    23,    25,    15,    24,
      23,    25,    14,    24,    -1,    23,    13,    24,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    23,
      25,    14,    24,    23,    25,    13,    24,    -1,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    37,
      23,    25,    14,    24,    -1,    23,    13,    24,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    37,
      23,    25,    14,    24,    23,    25,    13,    24,    -1,    23,
      14,    24,    23,    15,    24,     3,    23,    25,    15,    24,
      23,    25,    14,    24,    -1,    23,    13,    24,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    23,
      25,    14,    24,    23,    25,    13,    24,    -1,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    37,
      23,    25,    14,    24,    -1,    23,    13,    24,    23,    14,
      24,    23,    15,    24,     3,    23,    25,    15,    24,    37,
      23,    25,    14,    24,    23,    25,    13,    24,    -1,    23,
      16,    24,    23,    18,    24,     3,    23,    25,    18,    24,
      23,    25,    16,    24,    -1,    23,    16,    24,    23,    17,
      24,     4,    23,    25,    17,    24,    23,    25,    16,    24,
      -1,    37,    23,    16,    24,    23,    18,    24,     3,    23,
      25,    18,    24,    23,    25,    16,    24,    -1,    37,    23,
      16,    24,    23,    17,    24,     4,    23,    25,    17,    24,
      23,    25,    16,    24,    -1,     3,    -1,     4,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    33,    33,    37,    38,    39,    40,    41,    42,    43,
      46,    72,    79,   116,   152,   188,   224,   236,   248,   260,
     275,   277,   281,   284,   306,   328,   351,   377,   407,   440,
     471,   504,   508,   512,   516,   522,   526
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRINGB", "STRINGA", "NUMBER", "DIPLH", 
  "DEFRULE", "STRICTRULE", "NAME", "FACT", "HEAD", "BODY", "NEG", "ATOM", 
  "PREDICATE", "TERM", "VAR", "CONST", "GREATER", "SUP", "INF", 
  "THEPROGRAM", "'<'", "'>'", "'/'", "'='", "$accept", "program", 
  "program2", "Greater", "Dedomena", "Rules", "atom_list", "Literal", 
  "Literal2", "atom", "atom_args", "met_stath", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    60,    62,    47,    61
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    27,    28,    29,    29,    29,    29,    29,    29,    29,
      30,    31,    32,    32,    32,    32,    32,    32,    32,    32,
      33,    33,    34,    35,    35,    35,    35,    36,    36,    36,
      36,    37,    37,    37,    37,    38,    38
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     8,     1,     1,     1,     2,     2,     2,     2,
      14,     8,    28,    28,    27,    27,    23,    23,    22,    22,
       1,     2,     1,    15,    22,    16,    23,    15,    22,    16,
      23,    15,    15,    16,    16,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     1,     0,     0,     0,     0,     5,
       4,     3,     9,     0,     0,     0,     0,     0,     8,     7,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,    35,    36,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    10,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    25,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,    18,     0,     0,
       0,    19,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,    14,     0,
       0,     0,    15,     0,     0,     0,     0,     0,    12,    28,
       0,    13,     0,     0,     0,     0,    30,    32,    31,     0,
       0,    34,    33
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,     8,     9,    10,    11,   133,   134,    33,    58,
     140,    47
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -153
static const short yypact[] =
{
     -11,    -7,    33,     1,  -153,     4,    18,     9,    61,  -153,
    -153,  -153,  -153,     2,     5,    32,    49,    -1,  -153,  -153,
    -153,    57,    65,    67,    68,    71,    70,    73,    84,    81,
      91,    87,    60,    76,    94,    77,    74,    78,    74,    79,
      80,    82,    83,    74,  -153,  -153,  -153,    99,    86,   101,
      86,    88,    89,   100,   107,    90,    66,    92,  -153,    93,
      95,   102,   104,    96,   103,    98,   105,   106,    97,   108,
     109,   111,   112,  -153,   113,   114,   110,   115,   116,   117,
     121,   118,   120,   131,   119,   126,   127,   122,   123,   124,
     129,   128,    74,    86,   125,   130,   132,    86,   133,   134,
     135,   139,   136,   138,   149,   141,   140,   150,   161,   151,
     142,   143,   154,   147,   148,   146,   152,   155,   153,   156,
     162,   157,   158,   159,   163,   164,   160,   165,  -153,   166,
     172,   169,     7,   168,  -153,   170,    17,   173,   171,    -3,
     174,   175,   176,   177,   167,    21,  -153,   179,   180,    23,
     181,   182,   186,    35,   183,   178,   184,   185,   192,   196,
     187,   198,   189,   190,   191,   193,   200,   194,   201,    43,
     197,   199,   195,   202,   204,   205,    45,   207,    64,  -153,
     208,   209,   211,   212,   210,    46,   203,   214,   215,   216,
     217,   218,    47,   219,   220,    69,  -153,    25,   222,   223,
     224,   221,   232,   225,    27,   226,   213,   227,   229,   228,
     243,   248,   230,   231,   244,    30,    50,   234,  -153,   235,
     236,   251,   249,    40,   238,   255,   241,   242,   245,   246,
     261,   264,   247,   258,   259,    51,  -153,  -153,   250,   252,
     260,  -153,   253,   254,   257,   256,   262,   263,   265,   266,
     267,   268,   269,  -153,   270,   271,  -153,   272,   273,   206,
     276,   274,   275,   277,   278,   280,   281,   279,   283,   284,
     294,   285,   286,   295,   293,   289,   288,   290,   291,   282,
     292,  -153,   296,   298,   299,   300,   301,   302,   309,   305,
     303,   306,   311,  -153,   304,   307,   308,   310,  -153,   312,
     313,   314,  -153,   315,   318,   319,   316,   317,  -153,  -153,
     320,  -153,   321,   322,   324,   327,  -153,  -153,  -153,   323,
     325,  -153,  -153
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -153,  -153,  -153,   330,   340,   342,  -124,   -48,  -153,  -153,
    -152,   -35
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      57,   137,    60,    49,   170,     6,    13,    14,    54,    15,
     177,    21,     1,   151,    23,     3,    13,    14,    16,    15,
      66,    67,   152,    12,    27,     5,    22,     7,    16,    24,
      66,    67,   144,     4,    66,    67,    66,    67,    66,    67,
      66,    67,   148,    66,    67,   102,   158,   217,   161,   106,
     214,   165,   222,    66,    67,   233,    25,   101,   198,   151,
     166,   151,   165,   165,   205,   240,   151,   165,   184,    26,
     191,   201,   209,    40,    41,   234,   252,    45,    46,    66,
      67,   193,   194,    28,    17,   146,   212,   213,    29,   146,
      36,    31,    37,    30,    32,    35,    34,    38,    39,    42,
      43,    44,    48,    50,    51,    55,    52,    59,    53,    56,
      63,    61,    62,    64,    65,    68,    71,    69,    70,    72,
      73,    75,    78,    91,    74,    84,     0,    87,    88,    76,
      77,    79,    89,    85,    80,    81,    82,    92,    86,    83,
      94,    90,    95,    93,    99,   110,    96,    97,    98,   103,
     146,   100,   113,   114,   104,   105,   107,   146,   108,   111,
     109,   112,   116,   115,   117,     0,   118,   119,   120,   121,
     122,   124,   123,   129,   135,   142,   125,   127,   126,   157,
     128,   130,   132,   131,   143,   138,   150,   136,   139,     0,
     141,   145,   160,     0,   147,   167,   149,   153,   154,   155,
     164,   156,   159,   168,   172,   162,   163,   169,   173,   171,
     175,   174,   176,   178,   181,   179,   183,   180,   182,   187,
     185,   224,   186,   271,   200,     0,   188,   189,   202,   190,
     192,   195,   208,   196,   197,   219,   199,   203,   204,   220,
     207,   206,   227,   210,   211,   215,   216,   228,   218,   223,
     221,   229,   225,   226,   230,   231,   232,   235,   238,   236,
     237,   239,   241,   242,   243,   247,   244,   248,   245,   246,
     250,   249,   255,   251,   253,     0,   254,   256,     0,   257,
     258,   259,     0,   266,     0,   269,   261,   260,   262,   263,
     291,   264,   265,   267,   272,   268,   287,     0,   270,   273,
     274,   276,   275,   277,   279,   278,   280,   282,   281,   283,
     284,   286,   285,   288,   290,   289,   299,   292,   300,   303,
     293,   294,   295,     0,   296,   297,   298,   310,   301,   304,
     302,   306,   305,   307,   312,   313,   308,   309,    18,   311,
     319,   314,   315,   320,   316,   317,   318,   321,    19,   322,
      20
};

static const short yycheck[] =
{
      48,   125,    50,    38,   156,     1,     7,     8,    43,    10,
     162,     9,    23,    16,     9,    22,     7,     8,    19,    10,
      13,    14,    25,     5,    25,    24,    24,    23,    19,    24,
      13,    14,    25,     0,    13,    14,    13,    14,    13,    14,
      13,    14,    25,    13,    14,    93,    25,   199,    25,    97,
      25,    16,    25,    13,    14,    25,    24,    92,   182,    16,
      25,    16,    16,    16,   188,    25,    16,    16,    25,    20,
      25,    25,    25,    13,    14,    25,    25,     3,     4,    13,
      14,    17,    18,    26,    23,   133,    17,    18,    23,   137,
       6,    23,    11,    26,    23,    22,    26,     6,    11,    23,
       6,    24,    24,    24,    24,     6,    24,     6,    25,    23,
      10,    23,    23,     6,    24,    23,    14,    24,    23,    15,
      24,    23,    25,     3,    21,    11,    -1,    11,    11,    24,
      24,    23,    11,    23,    25,    24,    24,     6,    23,    26,
      14,    23,    15,    24,    15,     6,    24,    24,    24,    24,
     198,    23,     3,    12,    24,    23,    23,   205,    24,    23,
      25,    23,    12,    23,     3,    -1,    15,    25,    25,    15,
      23,    25,    24,    11,    11,     3,    24,    24,    23,    12,
      24,    24,    23,    25,    15,    25,    15,    23,    23,    -1,
      24,    23,    12,    -1,    24,    12,    23,    23,    23,    23,
      14,    24,    23,    25,    12,    24,    24,    23,    12,    24,
      12,    24,    23,    23,    14,    24,    15,    24,    24,    24,
      23,     8,    23,    17,    14,    -1,    24,    23,    25,    24,
      23,    23,    14,    24,    23,    14,    24,    23,    23,     7,
      23,    25,    14,    24,    24,    23,    23,     4,    24,    23,
      25,     3,    25,    24,    24,    24,    12,    23,     7,    24,
      24,    12,    24,     8,    23,     4,    24,     3,    23,    23,
      12,    24,    12,    14,    24,    -1,    24,    24,    -1,    25,
      23,    25,    -1,    14,    -1,    13,    23,    25,    23,    23,
       8,    24,    24,    23,    18,    24,     7,    -1,    25,    25,
      25,    23,    25,    23,    25,    24,    23,    13,    24,    24,
      24,    18,    17,    25,    23,    25,     7,    25,    13,     8,
      24,    23,    23,    -1,    24,    24,    24,    13,    25,    25,
      24,    23,    25,    23,    16,    16,    24,    24,     8,    24,
      16,    25,    25,    16,    24,    24,    24,    24,     8,    24,
       8
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    23,    28,    22,     0,    24,     1,    23,    29,    30,
      31,    32,     5,     7,     8,    10,    19,    23,    30,    31,
      32,     9,    24,     9,    24,    24,    20,    25,    26,    23,
      26,    23,    23,    35,    26,    22,     6,    11,     6,    11,
      13,    14,    23,     6,    24,     3,     4,    38,    24,    38,
      24,    24,    24,    25,    38,     6,    23,    34,    36,     6,
      34,    23,    23,    10,     6,    24,    13,    14,    23,    24,
      23,    14,    15,    24,    21,    23,    24,    24,    25,    23,
      25,    24,    24,    26,    11,    23,    23,    11,    11,    11,
      23,     3,     6,    24,    14,    15,    24,    24,    24,    15,
      23,    38,    34,    24,    24,    23,    34,    23,    24,    25,
       6,    23,    23,     3,    12,    23,    12,     3,    15,    25,
      25,    15,    23,    24,    25,    24,    23,    24,    24,    11,
      24,    25,    23,    33,    34,    11,    23,    33,    25,    23,
      37,    24,     3,    15,    25,    23,    34,    24,    25,    23,
      15,    16,    25,    23,    23,    23,    24,    12,    25,    23,
      12,    25,    24,    24,    14,    16,    25,    12,    25,    23,
      37,    24,    12,    12,    24,    12,    23,    37,    23,    24,
      24,    14,    24,    15,    25,    23,    23,    24,    24,    23,
      24,    25,    23,    17,    18,    23,    24,    23,    33,    24,
      14,    25,    25,    23,    23,    33,    25,    23,    14,    25,
      24,    24,    17,    18,    25,    23,    23,    37,    24,    14,
       7,    25,    25,    23,     8,    25,    24,    14,     4,     3,
      24,    24,    12,    25,    25,    23,    24,    24,     7,    12,
      25,    24,     8,    23,    24,    23,    23,     4,     3,    24,
      12,    14,    25,    24,    24,    12,    24,    25,    23,    25,
      25,    23,    23,    23,    24,    24,    14,    23,    24,    13,
      25,    17,    18,    25,    25,    25,    23,    23,    24,    25,
      23,    24,    13,    24,    24,    17,    18,     7,    25,    25,
      23,     8,    25,    24,    23,    23,    24,    24,    24,     7,
      13,    25,    24,     8,    25,    25,    23,    23,    24,    24,
      13,    24,    16,    16,    25,    25,    24,    24,    24,    16,
      16,    24,    24
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 34 "_yacc_xml.y"
    {;}
    break;

  case 9:
#line 43 "_yacc_xml.y"
    { yyerrok; puts("WRONG!Wrong program component!"); ok=0;}
    break;

  case 10:
#line 47 "_yacc_xml.y"
    {
                /*8elw na brw an oi duo kanones uparxoun ston symbol table */
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                find = lookup_symboltable(yyvsp[-8].s_type);
                if(find == NULL){
                        printf("\nWRONG!In line %d Rule <%s> has not Defined!\n",lineno,yyvsp[-8].s_type);
                        ok=0;
                }
                find = lookup_symboltable(yyvsp[-3].s_type);
                if(find == NULL){
                        printf("\nWRONG!In line %d Rule <%s> has not Defined!\n",lineno,yyvsp[-3].s_type);
                        ok=0;
                }
                else{
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 5;
                        data->types.great = (struct greater*)malloc(sizeof(struct greater));
                        data->types.great->rule1 = strdup(yyvsp[-8].s_type);
                        data->types.great->rule2 = strdup(yyvsp[-3].s_type);
                        insert_symboltable(data);
                        ++top;
                }
                }
    break;

  case 11:
#line 73 "_yacc_xml.y"
    {
                assert(yyval.s_type = strdup(yyvsp[-4].s_type));
                }
    break;

  case 12:
#line 80 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        /*printf("before:%d\n",top);*/
        find = lookup_symboltable(yyvsp[-22].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-22].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-22].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-22].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-22].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-22].s_type);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-22].s_type);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 1;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",yyvsp[-22].s_type,lineno);
                ok=0;
        }
	}
    break;

  case 13:
#line 117 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-22].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-22].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-22].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-22].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-22].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-22].s_type);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-22].s_type);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 2;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",yyvsp[-22].s_type,lineno);
                ok=0;
        }
        }
    break;

  case 14:
#line 153 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-21].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-21].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-21].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-21].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-21].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-21].s_type);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-21].s_type);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 1;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("WRONG!Rule <%s> in line %d redefine!\n",yyvsp[-21].s_type,lineno);
                ok=0;
        }
        }
    break;

  case 15:
#line 189 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable(yyvsp[-21].s_type);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable(yyvsp[-21].s_type,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",yyvsp[-21].s_type,lineno);
                        ok=0;
                }
                if(lookup_generaltable(yyvsp[-21].s_type,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",yyvsp[-21].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup(yyvsp[-21].s_type);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup(yyvsp[-21].s_type);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 2;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",yyvsp[-21].s_type,lineno);
                ok=0;
        }
        }
    break;

  case 16:
#line 225 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
        }
    break;

  case 17:
#line 237 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
        }
    break;

  case 18:
#line 249 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
        }
    break;

  case 19:
#line 261 "_yacc_xml.y"
    {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
        }
    break;

  case 20:
#line 276 "_yacc_xml.y"
    {;}
    break;

  case 21:
#line 278 "_yacc_xml.y"
    {;}
    break;

  case 23:
#line 285 "_yacc_xml.y"
    {
                if(lookup_generaltable(yyvsp[-8].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-8].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-8].s_type);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-8].s_type);
                        data->types.ded->not = 2;
                        insert_symboltable(data);
                        ++top;
                }
                assert(yyval.s_type = strdup(yyvsp[-8].s_type));
                }
    break;

  case 24:
#line 307 "_yacc_xml.y"
    {
                if(lookup_generaltable(yyvsp[-12].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-12].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-12].s_type);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-12].s_type);
                        data->types.ded->not = 1;
                        insert_symboltable(data);
                        ++top;
                }
                assert(yyval.s_type = strdup(yyvsp[-12].s_type));
                }
    break;

  case 25:
#line 329 "_yacc_xml.y"
    {
                if(lookup_generaltable(yyvsp[-9].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-9].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-9].s_type);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-9].s_type);
                        data->types.ded->arguments = insert_args_to_table(yyvsp[-4].s_type);
                        data->types.ded->not = 2;
                        insert_symboltable(data);
                        ++top;
                }
                assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-9].s_type,strdup("(")),yyvsp[-4].s_type),strdup(")"))));
                }
    break;

  case 26:
#line 352 "_yacc_xml.y"
    {
                if(lookup_generaltable(yyvsp[-13].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-13].s_type,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup(yyvsp[-13].s_type);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup(yyvsp[-13].s_type);
                        data->types.ded->arguments = insert_args_to_table(yyvsp[-8].s_type);
                        data->types.ded->not = 1;
                        insert_symboltable(data);
                        ++top;
                }
                assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-13].s_type,strdup("(")),yyvsp[-8].s_type),strdup(")"))));
                }
    break;

  case 27:
#line 378 "_yacc_xml.y"
    {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable(yyvsp[-8].s_type,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable(yyvsp[-8].s_type,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-8].s_type,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-8].s_type);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup(yyvsp[-8].s_type);
                                data->types.ded->not = 2;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d Predicate <%s> redefine!\n",lineno,yyvsp[-8].s_type);
                        ok=0;
                }
                assert(yyval.s_type = strdup(yyvsp[-8].s_type));
                }
    break;

  case 28:
#line 408 "_yacc_xml.y"
    {
                /*8elw na eisagw enan kathgorhma ston body table */
                if(body_table[top])
                        find = lookup_bodytable(yyvsp[-12].s_type,body_table[top]);
                else
                        find = lookup_bodytable(yyvsp[-12].s_type,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable(yyvsp[-12].s_type,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-12].s_type,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-12].s_type);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup(yyvsp[-12].s_type);
                                data->types.ded->not = 1;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d predicate <%s> redefine!\n",lineno,yyvsp[-12].s_type);
                        ok=0;
                }
		assert(yyval.s_type = strdup(yyvsp[-12].s_type));
                }
    break;

  case 29:
#line 441 "_yacc_xml.y"
    {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable(yyvsp[-9].s_type,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable(yyvsp[-9].s_type,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-9].s_type,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-9].s_type);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup(yyvsp[-9].s_type);
                                data->types.ded->arguments = insert_args_to_table(yyvsp[-4].s_type);
                                data->types.ded->not = 2;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d predicate <%s> redefine!\n",lineno,yyvsp[-9].s_type);
                        ok=0;
                }
		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-9].s_type,strdup("(")),yyvsp[-4].s_type),strdup(")"))));
                }
    break;

  case 30:
#line 472 "_yacc_xml.y"
    {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable(yyvsp[-13].s_type,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable(yyvsp[-13].s_type,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",yyvsp[-13].s_type,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup(yyvsp[-13].s_type);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup(yyvsp[-13].s_type);
                                data->types.ded->arguments = insert_args_to_table(yyvsp[-8].s_type);
                                data->types.ded->not = 1;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d Predicate <%s> redefine!\n",lineno,yyvsp[-13].s_type);
                        ok=0;
                }
		assert(yyval.s_type = strdup(strcat(strcat(strcat(yyvsp[-13].s_type,strdup("(")),yyvsp[-8].s_type),strdup(")"))));
                }
    break;

  case 31:
#line 505 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(yyvsp[-8].s_type));
		}
    break;

  case 32:
#line 509 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(yyvsp[-8].s_type));
		}
    break;

  case 33:
#line 513 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-8].s_type,","),yyvsp[-15].s_type)));
		}
    break;

  case 34:
#line 517 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(strcat(strcat(yyvsp[-8].s_type,","),yyvsp[-15].s_type)));
		}
    break;

  case 35:
#line 523 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(yyvsp[0].s_type)); 
		}
    break;

  case 36:
#line 527 "_yacc_xml.y"
    {
		assert(yyval.s_type = strdup(yyvsp[0].s_type)); 
		}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1800 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 532 "_yacc_xml.y"

#include <stdio.h>

void yyerror(char *s){
  printf("\nWRONG!Syntax error in line %d\n ", lineno);
  ok=0;
}

int main() {
int i;
  yyparse();
	/*for(i=0; i<=top; ++i){
		print_bodytable(body_table[i]);
		printf("i=%d\n",i);
		puts("---------");
	}
	printf("\n---top = %d---\n",top);
	print_symboltable();*/

	/* PARAGWGH APOTELESMATWN*/
	if(ok==1)
		produce_code();
	return(0);
}
/*-------------------------------------------------------------------------*/
/* paragei code gia olo to programma					   */
/*-------------------------------------------------------------------------*/
void produce_code(void){
int i;

for(i=0; i<top; ++i){
	//kanonas
	if(symbol_table[i]->index==1){
		//kanonas me label
		if(symbol_table[i]->types.kan->kind1==1){
			//kanonas me body
			if(symbol_table[i]->types.kan->kind2==1){
				//tou stul	R2: p(x,a),u -> l(w)
				if(symbol_table[i]->types.kan->telesths==2)
					produce_rules(1,i);
				//tou stul     R2: p(x,a),u => l(w)
				else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(2,i);
			}
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul     R2:  -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(3,i);
                                //tou stul     R2:  => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(4,i);
                        }
		}
                //kanonas xwris label
                else if(symbol_table[i]->types.kan->kind1==2){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      p(x,a),u -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(5,i);
                                //tou stul      p(x,a),u => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(6,i);
                        }
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
				//tou stul      -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(7,i);
                                //tou stul      => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(8,i);
                        }
		}
	}
        //gegonos
        else if(symbol_table[i]->index==2){
                produce_atoms(symbol_table[i],2);
        }
	//greater
	else if(symbol_table[i]->index=5){
		printf("%s>%s.\n",symbol_table[i]->types.great->rule1,symbol_table[i]->types.great->rule2);
	}
}
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h -k			   */
/*-------------------------------------------------------------------------*/
void produce_atoms(struct list *lista,int y){
	//lista:deikths pros thn alusida pou periexei ta stoixeia
	//y:	1:atoms se enan kanona	2:atoms se ena gegonos
struct list *current;
int i,j,notflag,not;
char *temp,*name,*args;
temp = (char *)malloc(100*sizeof(char *));
//name = (char *)malloc(100*sizeof(char *));
//args = (char *)malloc(100*sizeof(char *));

  //olh h plhroforia pou xreiazomaste einai
  //1)ean exw r1>r2 'h -p(a) 2)ton deikth ston kombo
  if(!lista){
	puts("WRONG! No symbols!");
	return;
  }
name = lista->types.ded->name;
not = lista->types.ded->not;
if(not==1){
	printf("-");
}
printf("%s",name);
	
//an uparxoun argument ta tupwnw.PRSX! me antistrofh seira!
	
if(lista->types.ded->arguments!=NULL){
	printf("(");
        current = lista->types.ded->arguments;
        i = countelements(current);
        for(j=i; j>0; --j){
		current = findelement(j,lista->types.ded->arguments);
		//Metablhth
		if(current->index==3){
			printf("%s",current->types.met->name);
		}
		//sta8era
		else if(current->index==4){
			printf("%s",current->types.stath->name);
		}
		//ean uparxei 
		if(j>1)
			printf(",");
	}
	printf(")");
}
if(y==2)
	printf(".\n");
}
/*-------------------------------------------------------------------------*/
/* paragei kwdika gia kanones*/
/*-------------------------------------------------------------------------*/
void produce_rules(int kindoftags,int epipedo){
	//kindoftags 1-8:rule tags
	//epipedo:epipedo sto opoio briskomaste
struct list *lista;
int i=0,j=0;
        //tou stul      R2: p(x,a),u -> l(w)
        if(kindoftags==1){
		//tupwnoume To R2: 
		printf("%s: ",symbol_table[epipedo]->types.kan->name);
		//tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
		lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
			//ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
			if(j>2)
				printf(",");
                }
		printf(" -> ");
		//tupwnoume to l(w)
		lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
		printf(".\n");
        }
        //tou stul     R2: p(x,a),u => l(w)
        if(kindoftags==2){
                //tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
			//ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" => ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul     R2:  -> l(w)
        if(kindoftags==3){
		//tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
		printf(" -> ");
                produce_atoms(body_table[epipedo],1);
		printf(".\n");
        }
        //tou stul	R2:  => l(w)
        if(kindoftags==4){
                //tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
                printf(" => ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
        //tou stul	p(x,a),u -> l(w)
        if(kindoftags==5){
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
                        //ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" -> ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul	p(x,a),u => l(w)
        if(kindoftags==6){
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
                        //ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" => ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul      -> l(w)
        if(kindoftags==7){
                printf(" -> ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
        //tou stul      => l(w)
        if(kindoftags==8){
		printf(" => ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
}
/*-------------------------------------------------------------------------*/
/* Sunarthsh h opoia pairnei to string a,X,AA,ka kai to topo8etei katallhla */
/* sto katallhlo table*/
/*-------------------------------------------------------------------------*/
struct list *insert_args_to_table(char *args){
struct list *current,*head;
int i,j;
//h k metraei posa attributes exei ena string px to a,X,AA,ka exei 4
int k;
char *temp;
temp = (char *)malloc(100*sizeof(char *));
head=current=NULL;

        if(args){
                j=0;
                k=0;
                while(args[j] != '\0') {
                        for (i = 0;  args[j] != ',' && args[j]!='\0';  ++i, ++j){
                                temp[i] = args[j];
                        }
                        //edw exei 3exwrisei to ena attribute px to X
                        temp[i] = '\0';
                        ++k;
                        if(args[j]!='\0')
                                ++j;
                        //Metablhth
                        if(isupper(temp[0])){
				//elegxw ean h metavlhth exei eisax8ei ws onoma kanona
				if(lookup_generaltable(temp,0)!=NULL){
					printf("\nWRONG!Variable <%s> in line %d is already defined as Rule!\n",temp,lineno);
					ok=0;
				}
				else {
					gen = (struct general*)malloc(sizeof(struct general));
					gen->index = 3;
					gen->name = strdup(temp);
					insert_info_togeneraltable(gen);
					data2 = (struct list*)malloc(sizeof(struct list));
					data2->index = 3;
					data2->types.met = (struct metavlhth*)malloc(sizeof(struct metavlhth));
                        	        data2->types.met->name = strdup(temp);
				}
                        }
                        //sta8era
                        else {
				if(lookup_generaltable(temp,1)!=NULL){
					printf("\nWRONG!Constant <%s> in line %d is already defined as Predicate!\n",temp,lineno);
					ok=0;
				}
                                if(lookup_generaltable(temp,0)!=NULL){
                                        printf("\nWRONG!Constant <%s> in line %d is already defined as Rule!\n",temp,lineno);
					ok=0;
                                }
				else {
                                        gen = (struct general*)malloc(sizeof(struct general));
                                        gen->index = 4;
                                        gen->name = strdup(temp);
                                        insert_info_togeneraltable(gen);
	                                data2 = (struct list*)malloc(sizeof(struct list));
        	                        data2->index = 4;
                	                data2->types.stath = (struct stathera*)malloc(sizeof(struct stathera));
                        	        data2->types.stath->name = strdup(temp);
				}
                        }
                        if(k==1){
				head = data2;
				head->next=NULL;
                        }
                        else {
				current = head;
				if(current==NULL)
					puts("WRONG!");
                                while(current){
					if(current->next==NULL)
						break;
					else
		                                current=current->next;
				}
				current->next=data2;
				data2->next=NULL;
                        }
                }//while
        }//if
	return(head);
}

